Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 824)
+++ palm/trunk/SOURCE/Makefile	(revision 825)
@@ -4,5 +4,5 @@
 # Current revisions:
 # ------------------
-# 
+# wang_kernel renamed lpm_collision_kernels
 #
 # Former revisions:
@@ -83,7 +83,7 @@
 	init_masks.f90 init_ocean.f90 init_particles.f90 init_pegrid.f90 \
 	init_pt_anomaly.f90 init_rankine.f90 init_slope.f90 \
-	interaction_droplets_ptq.f90 local_flush.f90 \
-        local_getenv.f90 local_stop.f90 local_system.f90 local_tremain.f90 \
-	local_tremain_ini.f90 message.f90 modules.f90 netcdf.f90 \
+	interaction_droplets_ptq.f90 local_flush.f90 local_getenv.f90 \
+	local_stop.f90 local_system.f90 local_tremain.f90 local_tremain_ini.f90 \
+        lpm_collision_kernels.f90 message.f90 modules.f90 netcdf.f90 \
 	package_parin.f90 palm.f90 parin.f90 particle_boundary_conds.f90 \
         plant_canopy_model.f90 poisfft.f90 \
@@ -108,5 +108,5 @@
 	user_particle_attributes.f90 user_read_restart_data.f90 \
 	user_spectra.f90 user_statistics.f90 wall_fluxes.f90 \
-	wang_kernel.f90 write_3d_binary.f90 write_compressed.f90 \
+	write_3d_binary.f90 write_compressed.f90 \
 	write_var_list.f90
 
@@ -124,11 +124,13 @@
 	data_output_3d.o diffusion_e.o diffusion_s.o diffusion_u.o \
 	diffusion_v.o diffusion_w.o diffusivities.o disturb_field.o \
-	disturb_heatflux.o eqn_state_seawater.o exchange_horiz.o exchange_horiz_2d.o fft_xy.o \
-	flow_statistics.o global_min_max.o header.o impact_of_latent_heat.o \
-	inflow_turbulence.o init_1d_model.o init_3d_model.o init_advec.o init_cloud_physics.o \
-	init_coupling.o init_dvrp.o init_grid.o init_masks.o init_ocean.o init_particles.o init_pegrid.o \
-	init_pt_anomaly.o init_rankine.o init_slope.o \
+	disturb_heatflux.o eqn_state_seawater.o exchange_horiz.o \
+	exchange_horiz_2d.o fft_xy.o flow_statistics.o global_min_max.o \
+	header.o impact_of_latent_heat.o inflow_turbulence.o init_1d_model.o \
+	init_3d_model.o init_advec.o init_cloud_physics.o init_coupling.o \
+	init_dvrp.o init_grid.o init_masks.o init_ocean.o init_particles.o \
+	init_pegrid.o init_pt_anomaly.o init_rankine.o init_slope.o \
 	interaction_droplets_ptq.o local_flush.o local_getenv.o local_stop.o \
-	local_system.o local_tremain.o local_tremain_ini.o message.o modules.o \
+	local_system.o local_tremain.o local_tremain_ini.o \
+	lpm_collision_kernels.f90 message.o modules.o \
 	netcdf.o package_parin.o palm.o parin.o particle_boundary_conds.o \
         plant_canopy_model.o poisfft.o \
@@ -151,5 +153,5 @@
 	user_module.o user_parin.o user_particle_attributes.o \
 	user_read_restart_data.o user_spectra.o user_statistics.o \
-	wall_fluxes.o wang_kernel.o write_3d_binary.o write_compressed.o \
+	wall_fluxes.o write_3d_binary.o write_compressed.o \
 	write_var_list.o
 
@@ -181,5 +183,5 @@
 
 
-advec_particles.o: modules.o random_function.o wang_kernel.o
+advec_particles.o: modules.o lpm_collision_kernels.o random_function.o
 advec_s_bc.o: modules.o
 advec_s_pw.o: modules.o
@@ -257,4 +259,5 @@
 local_tremain.o: modules.o
 local_tremain_ini.o: modules.o
+lpm_collision_kernels.o: modules.o user_module.o
 message.o: modules.o
 modules.o: modules.f90
@@ -328,5 +331,4 @@
 user_statistics.o: modules.o user_module.o
 wall_fluxes.o: modules.o
-wang_kernel.o: modules.o user_module.o
 write_3d_binary.o: modules.o random_function.o
 write_compressed.o: modules.o
Index: palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- palm/trunk/SOURCE/advec_particles.f90	(revision 824)
+++ palm/trunk/SOURCE/advec_particles.f90	(revision 825)
@@ -4,7 +4,9 @@
 ! Current revisions:
 ! ------------------
-! droplet growth by condensation may include curvature and solution effects.
-! initialisation of temporary particle array for resorting removed.
-! particle attributes speed_x|y|z_sgs renamed rvar1|2|3.
+! droplet growth by condensation may include curvature and solution effects,
+! initialisation of temporary particle array for resorting removed,
+! particle attributes speed_x|y|z_sgs renamed rvar1|2|3,
+! module wang_kernel_mod renamed lpm_collision_kernels_mod,
+! wang_collision_kernel renamed wang_kernel
 !
 ! Former revisions:
@@ -130,4 +132,5 @@
     USE indices
     USE interfaces
+    USE lpm_collision_kernels_mod
     USE netcdf_control
     USE particle_attributes
@@ -135,5 +138,4 @@
     USE random_function_mod
     USE statistics
-    USE wang_kernel_mod
 
     IMPLICIT NONE
@@ -200,9 +202,5 @@
     CALL cpu_log( log_point(25), 'advec_particles', 'start' )
 
-!    IF ( number_of_particles /= number_of_tails )  THEN
-!       WRITE (9,*) '--- advec_particles: #1'
-!       WRITE (9,*) '    #of p=',number_of_particles,' #of t=',number_of_tails
-!       CALL local_flush( 9 )
-!    ENDIF
+
 !
 !-- Write particle data on file for later analysis.
@@ -270,16 +268,4 @@
     CALL cpu_log( log_point_s(41), 'advec_part_exp', 'stop' )
 
-!    WRITE ( 9, * ) '*** advec_particles: ##0.3'
-!    CALL local_flush( 9 )
-!    nd = 0
-!    DO  n = 1, number_of_particles
-!       IF ( .NOT. particle_mask(n) )  nd = nd + 1
-!    ENDDO
-!    IF ( nd /= deleted_particles ) THEN
-!       WRITE (9,*) '*** nd=',nd,' deleted_particles=',deleted_particles
-!       CALL local_flush( 9 )
-!       CALL MPI_ABORT( comm2d, 9999, ierr )
-!    ENDIF
-
 !
 !-- Particle (droplet) growth by condensation/evaporation and collision
@@ -357,157 +343,6 @@
 !
 !--       Change in radius by condensation/evaporation
-          IF ( curvature_solution_effects .AND. particles(n)%radius < 1.0E-6 ) &
-          THEN
-!
-!--          Curvature and solutions effects are included in growth equation.
-!--          Change in Radius is calculated with 4th-order Rosenbrock method
-!--          for stiff o.d.e's with monitoring local truncation error to adjust
-!--          stepsize (see Numerical recipes in FORTRAN, 2nd edition, p. 731).
-!--          For larger radii the simple analytic method (see ELSE) gives
-!--          almost the same results.
-!
-!--          Surface tension after (Straka, 2009)
-             sigma = 0.0761 - 0.00155 * ( t_int - 273.15 )
-
-             r_ros = particles(n)%radius
-             dt_ros_sum  = 0.0      ! internal integrated time (s)
-             internal_timestep_count = 0
-
-             ddenom  = 1.0 / ( rho_l * r_v * t_int / ( e_s * diff_coeff_l ) +  &
-                               ( l_v / ( r_v * t_int ) - 1.0 ) *               &
-                               rho_l * l_v / ( thermal_conductivity_l * t_int )&
-                             )
-              
-             afactor = 2.0 * sigma / ( rho_l * r_v * t_int )
-
-             IF ( particles(n)%rvar3 == -9999999.9 )  THEN
-!
-!--             First particle timestep. Derivative has to be calculated.
-                drdt_m  = ddenom / r_ros * ( e_a / e_s - 1.0 -    &
-                                             afactor / r_ros +    &
-                                             bfactor / r_ros**3 )
-             ELSE
-!
-!--             Take value from last PALM timestep
-                drdt_m = particles(n)%rvar3
-             ENDIF
-!
-!--          Take internal timestep values from the end of last PALM timestep
-             dt_ros_last = particles(n)%rvar1
-             dt_ros_next = particles(n)%rvar2
-!
-!--          Internal timestep must not be larger than PALM timestep
-             dt_ros = MIN( dt_ros_next, dt_3d )
-!
-!--          Integrate growth equation in time unless PALM timestep is reached
-             DO WHILE ( dt_ros_sum < dt_3d )
-
-                internal_timestep_count = internal_timestep_count + 1
-
-!
-!--             Derivative at starting value
-                drdt = ddenom / r_ros * ( e_a / e_s - 1.0 - afactor / r_ros + &
-                                          bfactor / r_ros**3 )
-                drdt_ini       = drdt
-                dt_ros_sum_ini = dt_ros_sum
-                r_ros_ini      = r_ros
-
-!
-!--             Calculate time derivative of dr/dt
-                d2rdt2 = ( drdt - drdt_m ) / dt_ros_last 
-
-!
-!--             Calculate radial derivative of dr/dt
-                d2rdtdr = ddenom * ( ( 1.0 - e_a/e_s ) / r_ros**2 + &
-                                     2.0 * afactor / r_ros**3 -     &
-                                     4.0 * bfactor / r_ros**5 )
-!
-!--             Adjust stepsize unless required accuracy is reached
-                DO  jtry = 1, maxtry+1
-
-                   IF ( jtry == maxtry+1 )  THEN
-                      message_string = 'maxtry > 40 in Rosenbrock method'
-                      CALL message( 'advec_particles', 'PA0347', 2, 2, 0, 6, 0 )
-                   ENDIF
-
-                   aa    = 1.0 / ( gam * dt_ros ) - d2rdtdr
-                   g1    = ( drdt_ini + dt_ros * c1x * d2rdt2 ) / aa
-                   r_ros = r_ros_ini + a21 * g1
-                   drdt  = ddenom / r_ros * ( e_a / e_s - 1.0 - &
-                                              afactor / r_ros + &
-                                              bfactor / r_ros**3 )
-
-                   g2    = ( drdt + dt_ros * c2x * d2rdt2 + c21 * g1 / dt_ros )&
-                           / aa
-                   r_ros = r_ros_ini + a31 * g1 + a32 * g2
-                   drdt  = ddenom / r_ros * ( e_a / e_s - 1.0 - &
-                                              afactor / r_ros + &
-                                              bfactor / r_ros**3 )
-
-                   g3    = ( drdt + dt_ros * c3x * d2rdt2 + &
-                             ( c31 * g1 + c32 * g2 ) / dt_ros ) / aa
-                   g4    = ( drdt + dt_ros * c4x * d2rdt2 + &
-                             ( c41 * g1 + c42 * g2 + c43 * g3 ) / dt_ros ) / aa
-                   r_ros = r_ros_ini + b1 * g1 + b2 * g2 + b3 * g3 + b4 * g4
-
-                   dt_ros_sum = dt_ros_sum_ini + dt_ros
-
-                   IF ( dt_ros_sum == dt_ros_sum_ini )  THEN
-                      message_string = 'zero stepsize in Rosenbrock method'
-                      CALL message( 'advec_particles', 'PA0348', 2, 2, 0, 6, 0 )
-                   ENDIF
-!
-!--                Calculate error
-                   err_ros = e1*g1 + e2*g2 + e3*g3 + e4*g4 
-                   errmax  = 0.0
-                   errmax  = MAX( errmax, ABS( err_ros / r_ros_ini ) ) / eps_ros
-!
-!--                Leave loop if accuracy is sufficient, otherwise try again
-!--                with a reduced stepsize
-                   IF ( errmax <= 1.0 )  THEN
-                      EXIT
-                   ELSE
-                      dt_ros = SIGN(                                           &
-                                    MAX( ABS( 0.9 * dt_ros * errmax**pshrnk ), &
-                                         shrnk * ABS( dt_ros ) ),              &
-                                    dt_ros                                     &
-                                   )
-                   ENDIF
-
-                ENDDO  ! loop for stepsize adjustment
-
-!
-!--             Calculate next internal timestep
-                IF ( errmax > errcon )  THEN
-                   dt_ros_next = 0.9 * dt_ros * errmax**pgrow
-                ELSE
-                   dt_ros_next = grow * dt_ros
-                ENDIF
-
-!
-!--             Estimated timestep is reduced if the PALM time step is exceeded
-                dt_ros_last = dt_ros
-                IF ( ( dt_ros_next + dt_ros_sum ) >= dt_3d )  THEN
-                   dt_ros = dt_3d - dt_ros_sum
-                ELSE
-                   dt_ros = dt_ros_next
-                ENDIF
-
-                drdt_m = drdt
-
-             ENDDO
-!
-!--          Store derivative and internal timestep values for next PALM step
-             particles(n)%rvar1 = dt_ros_last
-             particles(n)%rvar2 = dt_ros_next
-             particles(n)%rvar3 = drdt_m
-
-             new_r = r_ros
-!
-!--          Radius should not fall below 1E-8 because Rosenbrock method may
-!--          lead to errors otherwise
-             new_r = MAX( new_r, 1.0E-8 )
-
-          ELSE
+          IF ( particles(n)%radius >= 1.0E-6  .OR.  &
+               .NOT. curvature_solution_effects )  THEN
 !
 !--          Approximation for large radii, where curvature and solution
@@ -523,4 +358,158 @@
                 new_r = SQRT( arg )
              ENDIF
+          ENDIF
+
+          IF ( curvature_solution_effects  .AND.                              &
+               ( ( particles(n)%radius < 1.0E-6 ) .OR. ( new_r < 1.0E-6 ) ) ) &
+          THEN
+!
+!--          Curvature and solutions effects are included in growth equation.
+!--          Change in Radius is calculated with 4th-order Rosenbrock method
+!--          for stiff o.d.e's with monitoring local truncation error to adjust
+!--          stepsize (see Numerical recipes in FORTRAN, 2nd edition, p. 731).
+!--          For larger radii the simple analytic method (see ELSE) gives
+!--          almost the same results.
+!
+!--          Surface tension after (Straka, 2009)
+             sigma = 0.0761 - 0.00155 * ( t_int - 273.15 )
+
+             r_ros = particles(n)%radius
+             dt_ros_sum  = 0.0      ! internal integrated time (s)
+             internal_timestep_count = 0
+
+             ddenom  = 1.0 / ( rho_l * r_v * t_int / ( e_s * diff_coeff_l ) +  &
+                               ( l_v / ( r_v * t_int ) - 1.0 ) *               &
+                               rho_l * l_v / ( thermal_conductivity_l * t_int )&
+                             )
+              
+             afactor = 2.0 * sigma / ( rho_l * r_v * t_int )
+
+             IF ( particles(n)%rvar3 == -9999999.9 )  THEN
+!
+!--             First particle timestep. Derivative has to be calculated.
+                drdt_m  = ddenom / r_ros * ( e_a / e_s - 1.0 -    &
+                                             afactor / r_ros +    &
+                                             bfactor / r_ros**3 )
+             ELSE
+!
+!--             Take value from last PALM timestep
+                drdt_m = particles(n)%rvar3
+             ENDIF
+!
+!--          Take internal timestep values from the end of last PALM timestep
+             dt_ros_last = particles(n)%rvar1
+             dt_ros_next = particles(n)%rvar2
+!
+!--          Internal timestep must not be larger than PALM timestep
+             dt_ros = MIN( dt_ros_next, dt_3d )
+!
+!--          Integrate growth equation in time unless PALM timestep is reached
+             DO WHILE ( dt_ros_sum < dt_3d )
+
+                internal_timestep_count = internal_timestep_count + 1
+
+!
+!--             Derivative at starting value
+                drdt = ddenom / r_ros * ( e_a / e_s - 1.0 - afactor / r_ros + &
+                                          bfactor / r_ros**3 )
+                drdt_ini       = drdt
+                dt_ros_sum_ini = dt_ros_sum
+                r_ros_ini      = r_ros
+
+!
+!--             Calculate time derivative of dr/dt
+                d2rdt2 = ( drdt - drdt_m ) / dt_ros_last 
+
+!
+!--             Calculate radial derivative of dr/dt
+                d2rdtdr = ddenom * ( ( 1.0 - e_a/e_s ) / r_ros**2 + &
+                                     2.0 * afactor / r_ros**3 -     &
+                                     4.0 * bfactor / r_ros**5 )
+!
+!--             Adjust stepsize unless required accuracy is reached
+                DO  jtry = 1, maxtry+1
+
+                   IF ( jtry == maxtry+1 )  THEN
+                      message_string = 'maxtry > 40 in Rosenbrock method'
+                      CALL message( 'advec_particles', 'PA0347', 2, 2, 0, 6, 0 )
+                   ENDIF
+
+                   aa    = 1.0 / ( gam * dt_ros ) - d2rdtdr
+                   g1    = ( drdt_ini + dt_ros * c1x * d2rdt2 ) / aa
+                   r_ros = r_ros_ini + a21 * g1
+                   drdt  = ddenom / r_ros * ( e_a / e_s - 1.0 - &
+                                              afactor / r_ros + &
+                                              bfactor / r_ros**3 )
+
+                   g2    = ( drdt + dt_ros * c2x * d2rdt2 + c21 * g1 / dt_ros )&
+                           / aa
+                   r_ros = r_ros_ini + a31 * g1 + a32 * g2
+                   drdt  = ddenom / r_ros * ( e_a / e_s - 1.0 - &
+                                              afactor / r_ros + &
+                                              bfactor / r_ros**3 )
+
+                   g3    = ( drdt + dt_ros * c3x * d2rdt2 + &
+                             ( c31 * g1 + c32 * g2 ) / dt_ros ) / aa
+                   g4    = ( drdt + dt_ros * c4x * d2rdt2 + &
+                             ( c41 * g1 + c42 * g2 + c43 * g3 ) / dt_ros ) / aa
+                   r_ros = r_ros_ini + b1 * g1 + b2 * g2 + b3 * g3 + b4 * g4
+
+                   dt_ros_sum = dt_ros_sum_ini + dt_ros
+
+                   IF ( dt_ros_sum == dt_ros_sum_ini )  THEN
+                      message_string = 'zero stepsize in Rosenbrock method'
+                      CALL message( 'advec_particles', 'PA0348', 2, 2, 0, 6, 0 )
+                   ENDIF
+!
+!--                Calculate error
+                   err_ros = e1*g1 + e2*g2 + e3*g3 + e4*g4 
+                   errmax  = 0.0
+                   errmax  = MAX( errmax, ABS( err_ros / r_ros_ini ) ) / eps_ros
+!
+!--                Leave loop if accuracy is sufficient, otherwise try again
+!--                with a reduced stepsize
+                   IF ( errmax <= 1.0 )  THEN
+                      EXIT
+                   ELSE
+                      dt_ros = SIGN(                                           &
+                                    MAX( ABS( 0.9 * dt_ros * errmax**pshrnk ), &
+                                         shrnk * ABS( dt_ros ) ),              &
+                                    dt_ros                                     &
+                                   )
+                   ENDIF
+
+                ENDDO  ! loop for stepsize adjustment
+
+!
+!--             Calculate next internal timestep
+                IF ( errmax > errcon )  THEN
+                   dt_ros_next = 0.9 * dt_ros * errmax**pgrow
+                ELSE
+                   dt_ros_next = grow * dt_ros
+                ENDIF
+
+!
+!--             Estimated timestep is reduced if the PALM time step is exceeded
+                dt_ros_last = dt_ros
+                IF ( ( dt_ros_next + dt_ros_sum ) >= dt_3d )  THEN
+                   dt_ros = dt_3d - dt_ros_sum
+                ELSE
+                   dt_ros = dt_ros_next
+                ENDIF
+
+                drdt_m = drdt
+
+             ENDDO
+!
+!--          Store derivative and internal timestep values for next PALM step
+             particles(n)%rvar1 = dt_ros_last
+             particles(n)%rvar2 = dt_ros_next
+             particles(n)%rvar3 = drdt_m
+
+             new_r = r_ros
+!
+!--          Radius should not fall below 1E-8 because Rosenbrock method may
+!--          lead to errors otherwise
+             new_r = MAX( new_r, 1.0E-8 )
 
           ENDIF
@@ -570,7 +559,7 @@
 !
 !--    Particle growth by collision
+       IF ( collision_kernel /= 'none' )  THEN
+
        CALL cpu_log( log_point_s(43), 'advec_part_coll', 'start' )
-
-       IF ( wang_collision_kernel ) THEN
 
        DO  i = nxl, nxr
